/*
 * Copyright 2018, Theodore Chabardes
 * <theodore.chabardes@mines-paristech.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _CONNEXITY_H_
#define _CONNEXITY_H_

#include "offset.hpp"
#include <iostream>
#include <vector>

// Types of possible structuring elements.
enum se_type { SE_UNKNOWN, SE_CROSS, SE_HEX, SE_SQUARE, SE_CROSS_3D, SE_CUBE };

struct structuring_element {
  structuring_element() {}
  structuring_element(bool is_odd) : odd(is_odd) {}
  void addOffset(const int &x, const int &y, const int &z) {
    o.push_back(offset(x, y, z));
  }

  std::vector<offset> o;
  bool odd;
};

structuring_element get_structuring_element(const se_type &c);

#endif // _CONNEXITY_H_
