/*
 * Copyright 2018, Theodore Chabardes
 * <theodore.chabardes@mines-paristech.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __DEBUG_HPP__
#define __DEBUG_HPP__

#define RED(txt) "\033[1;31m" << txt << "\033[0m"

#define PRINT_ARRAY(A_, DOMAIN, POS)                                           \
  for (size_t i_ = 0; i_ < DOMAIN.h; ++i_) {                                   \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)A_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)A_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << std::endl;                                                    \
  }                                                                            \
  std::cout << std::endl;

#define PRINT_2_ARRAY(A_, B_, DOMAIN, POS)                                     \
  for (size_t i_ = 0; i_ < DOMAIN.h; ++i_) {                                   \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)A_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)A_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << '\t';                                                         \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)B_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)B_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << std::endl;                                                    \
  }                                                                            \
  std::cout << std::endl;

#define PRINT_3_ARRAY(A_, B_, C_, DOMAIN, POS)                                 \
  for (size_t i_ = 0; i_ < DOMAIN.h; ++i_) {                                   \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)A_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)A_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << '\t';                                                         \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)B_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)B_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << '\t';                                                         \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)C_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)C_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << std::endl;                                                    \
  }                                                                            \
  std::cout << std::endl;

#define PRINT_4_ARRAY(A_, B_, C_, D_, DOMAIN, POS)                             \
  for (size_t i_ = 0; i_ < DOMAIN.h; ++i_) {                                   \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)A_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)A_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << '\t';                                                         \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)B_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)B_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << '\t';                                                         \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)C_[i_ * DOMAIN.w + j_]) << '\t';                 \
      else                                                                     \
        std::cout << (int)C_[i_ * DOMAIN.w + j_] << '\t';                      \
    }                                                                          \
    std::cout << '\t';                                                         \
    for (size_t j_ = 0; j_ < DOMAIN.w; ++j_) {                                 \
      if (i_ * DOMAIN.w + j_ == POS)                                           \
        std::cout << RED((int)D_[i_ * DOMAIN.w + j_]) << '\t';             \
      else                                                                     \
        std::cout << (int)D_[i_ * DOMAIN.w + j_] << '\t';                  \
    }                                                                          \
    std::cout << std::endl;                                                    \
  }                                                                            \
  std::cout << std::endl;

#endif // __DEBUG_HPP__
