/*
 * Copyright 2018, Theodore Chabardes
 * <theodore.chabardes@mines-paristech.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _OFFSET_H_
#define _OFFSET_H_

#include <cstddef>

// This is mainly used to define the structuring element.
struct offset {
  offset(int _x, int _y, int _z) : x(_x), y(_y), z(_z) {}

  int x;
  int y;
  int z;
};

struct domain {
  domain(size_t _w, size_t _h, size_t _d)
      : w(_w), h(_h), d(_d), line_len(_w * _h), vol(_w * _h * _d) {}
  size_t w;
  size_t h;
  size_t d;
  size_t line_len;
  size_t vol;
};

#endif // _OFFSET_H_
