/*
 * Copyright 2017, Theodore Chabardes
 * <theodore.chabardes@mines-paristech.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _TEST_CLASS_HPP_
#define _TEST_CLASS_HPP_

#include "../src/connexity.hpp"
#include <cstdlib>
#include <cstring>
#include <iostream>

struct test_class {
  test_class(unsigned char in[], unsigned char truth[], const size_t &w,
             const size_t &h, const se_type &c);
  test_class(unsigned char in[], unsigned char marker[], unsigned char truth[],
             const size_t &w, const size_t &h, const se_type &c);
  ~test_class();
  size_t width, height;
  unsigned char *in;
  unsigned char *markers;
  unsigned char *truth;
  unsigned char *out;
  structuring_element se;
  bool run();
  void print();
};

#ifndef WS
#define WS 255
#endif

// Macro for the main function of each test files.
#define RUN_AND_RET                                                            \
  if (!t.run()) {                                                              \
    t.print();                                                                 \
    return 1;                                                                  \
  }                                                                            \
  return 0;

#endif // _TEST_CLASS_HPP_
