/*
 * Copyright 1017, Theodore Chabardes
 * <theodore.chabardes@mines-paristech.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "test_class.hpp"

int main(void) {

  // clang-format off
  unsigned char a[176] = {
    1,   2,   2,   2,   3,   2,   2,   2,   2,   1,   2,
    1,   3,   2,   2,   3,   3,   4,   3,   2,   1,   1,
    1,   3,   2,   2,   4,  34,  60,  60,  59,   1,   2,
    1,   3,   2,   3,  36,  85,  83,  82,  58,   1,   2,
    2,   3,   4,  34,  75,  85,  83,  80,  58,   2,   2,
    2,   3,  18,  68,  74,  84,  80,  80,  48,   2,   3,
    2,   4,  26,  67,  72,  69,  69,  60,   1,   2,   2,
    4,   4,  26,  67,  62,  62,  26,   2,   2,   1,   2,
    3,   4,  26,  24,  21,  18,   2,   2,   2,   2,   2,
    3,   3,   7,   6,   4,   1,   2,   1,   1,   1,   1,
    2,   3,   4,  16,  14,  12,   3,   2,   2,   1,   2,
    2,   3,   5,  16,  19,  17,  17,   2,   1,   1,   2,
    3,   4,   5,  16,  19,  17,  16,   2,   1,   0,   1,
    3,   4,   5,  14,  19,  17,  16,   2,   1,   0,   1,
    2,   2,   3,   3,   3,   2,   1,   2,   1,   1,   1,
    2,   2,   3,   3,   2,   1,   1,   2,   1,   1,   1
  };

  unsigned char b[176] = {
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1,
    1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1,
    1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1,
    1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1,
    1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
  };

  unsigned char c[176] = {
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,  
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
  };
  // clang-format on

  test_class t(a, b, c, 11, 16, SE_CROSS);

  RUN_AND_RET;
}
