/*
 * Copyright 1017, Theodore Chabardes
 * <theodore.chabardes@mines-paristech.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "test_class.hpp"

int main(void) {

  // clang-format off
  unsigned char a[280] = {
  39,   2,   2,   2,   2,   2,   0,   1,   1,   1,   2,   5,   5,   5,  10,  18,  28,  29,  21,   9,
  21,   2,   3,   3,   3,   3,   1,   2,   2,   1,   2,   4,   5,   5,  25,  24,  35,  29,  10,   9,
   8,   7,   5,   5,   5,   6,   4,   5,   3,   1,   2,   4,   7,   7,  23,  42,  34,  26,  13,  11,
   7,   5,   3,   3,   2,   3,   3,   4,   4,   2,   2,   7,  10,  25,  33,  42,  24,  26,   8,   9,
   7,   3,   2,   2,   2,   2,   2,   4,   5,   3,   6,  11,  14,  23,  37,  41,  27,   7,   7,   4,
   5,   3,  57,  57,  57,   1,   1,   3,  13,  12,  23,  23,  22,  22,  37,  26,  12,   7,   7,   2,
   4,   3,  56,  57,  57,   2,   1,   3,  13,  12,  20,  20,  20,  29,  36,  26,   7,   4,   3,   2,
   3,   3,  55,  56,  56,   2,   1,   4,  16,  19,  15,  26,  20,  31,  30,  28,   9,   5,   4,   3,
   2,   3,   4,   3,   3,   3,   2,  10,  23,  20,  16,  36,  29,  35,  28,  15,  10,   4,   4,   3,
   4,   4,   5,   4,   9,   8,   6,  18,  23,  23,  14,  29,  27,  25,  25,  12,  12,   5,   4,   2,
   3,   3,   4,   6,   9,   8,   9,  27,  27,  19,  11,  40,  34,  28,  28,   5,   5,   3,   3,   3,
   2,   3,   4,   7,   9,  15,  17,  26,  31,  28,  32,  33,  33,  19,  14,   5,   5,   2,   3,   3,
   1,   3,   4,   7,   7,  17,  28,  24,  23,  35,  35,  33,  33,   5,   5,   5,   3,   1,   3,   3,
   3,   3,   6,  15,  20,  31,  31,  21,  24,  36,  32,  15,  10,   6,   6,   6,   4,   1,   3,   3
  };

  unsigned char b[280] = {
    0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2,
    3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2,
    3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2,
    3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2,
    3, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2,
    3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2,
    3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2
  };

  unsigned char c[280] = {
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,WS, 2, 2,
   WS, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,WS, 2, 2, 2,
    3,WS,WS,WS,WS,WS,WS,WS, 1, 1, 1, 1, 1, 1, 1,WS, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3, 1, 1, 1, 1, 1, 1, 1,WS, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3,WS, 1, 1, 1, 1, 1, 1,WS, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3,WS, 1, 1, 1, 1, 1,WS, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3,WS, 1, 1, 1, 1, 1,WS, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3, 3,WS, 1, 1, 1,WS, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3,WS, 1, 1, 1,WS, 2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3, 3, 1, 1,WS, 2, 2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3,WS, 1, 1,WS, 2, 2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3,WS, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3, 3,WS,WS, 2, 2, 2, 2, 2, 2, 2, 2, 2,
    3, 3, 3, 3, 3, 3, 3, 3, 3,WS, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,

  };
  // clang-format on

  test_class t(a, b, c, 20, 14, SE_CROSS);

  RUN_AND_RET;
}
