/*
 * Copyright 2017, Theodore Chabardes
 * <theodore.chabardes@mines-paristech.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <omp.h>
#include <stdio.h>

int main(void) {
#ifdef _OPENMP
#pragma omp parallel
  {
    printf("Hello from thread %d\n", omp_get_thread_num());
#pragma omp single
    { printf("Total number of OpenMP threads: %d\n", omp_get_num_threads()); }
  }
#else
  printf("_OPENMP has not been defined.");
#endif
  return 0;
}
